#ifndef D4L
#define D4L
#include "WTL.H"

#define D4R_0            0.4829629131445341561
#define D4R_1            0.8365163037378079425
#define D4R_2            0.2241438680420133889
#define D4R_3            0.1294095225512603697
//======================================================================
// D4
// 
scomplex U_D4(integer k){
    TRIG_VVARS
    S.Mas[0]=SET_ELEM( D4R_0,0);
    S.Mas[1]=SET_ELEM( D4R_1,0);
    S.Mas[2]=SET_ELEM( D4R_2,0);
    S.Mas[3]=SET_ELEM(-D4R_3,0);
    for(i=4;i<k;i++) S.Mas[i]=SET_ELEM(0,0);
    return S;
};
//======================================================================
// 
scomplex V_D4(integer k){
    TRIG_VVARS
    S.Mas[0]=SET_ELEM( -D4R_1,0);
    S.Mas[1]=SET_ELEM(  D4R_0,0);
    S.Mas[k-2]=SET_ELEM(D4R_3,0);
    S.Mas[k-1]=SET_ELEM(D4R_2,0);
    for(i=2;i<k-2;i++) S.Mas[i]=SET_ELEM(0,0);
    return S;
};
//======================================================================
//  D4:
scomplex* Filtrs_D4(integer k,integer p) {
    TRIG_FVARS
    WORK(D4)
    FREE_MEMORY
    return Filtr;
}
//======================================================================
//         
integer D4_MAX_ITER(integer k) {
    integer p=0;
    real d=k;
    while(1) {
		d/=2;
		if(d==(integer)d) p++;
		else break;
	}
    if(p) return p-2;
    return p;
};
#endif
